#!/usr/bin/env bash

if [ "$2" = "true" ]; then
  ffmpeg \
    -hide_banner \
    -hwaccel qsv \
    -hwaccel_output_format qsv \
    -hwaccel_device /dev/dri/renderD128 \
    -i $1 \
    -map_metadata -1 -map_chapters -1 \
    -vf "scale_qsv=-1:1080" \
    -map 0:0 \
    -c:v vp9_qsv \
    -color_range full \
    -colorspace bt709 -color_primaries bt709 \
    -color_trc iec61966-2-1 \
    -crf 31 -b:v 3M \
    -keyint_min 96 -g 96 \
    -row-mt 1 -tile-columns 2 \
    -deadline good -threads 12 \
    encoded/video-1080p-crf31-b3m.mp4

#    -hwaccel_device /dev/dri/renderD128 \ 
  ffmpeg \
    -hide_banner \
    -hwaccel qsv \
    -hwaccel_output_format qsv \
    -hwaccel_device /dev/dri/renderD128 \
    -i $1 \
    -map_metadata -1 -map_chapters -1 \
    -map 0:0 \
    -vf "scale_qsv=-1:720" \
    -c:v vp9_qsv \
    -color_range full \
    -colorspace bt709 -color_primaries bt709 \
    -color_trc iec61966-2-1 \
    -crf 32 -b:v 2M \
    -keyint_min 96 -g 96 \
    -row-mt 1 -tile-columns 2 \
    -deadline good -threads 12 \
    encoded/video-0720p-crf32-b2m.mp4

  # -vf "scale_qsv=-1:540,hwdownload"
  # -hwaccel_device /dev/dri/renderD128 \
  ffmpeg \
    -hide_banner \
    -hwaccel qsv \
    -hwaccel_output_format qsv \
    -hwaccel_device /dev/dri/renderD128 \
    -i $1 \
    -map_metadata -1 -map_chapters -1 \
    -map 0:0 \
    -vf "scale_qsv=-1:540" \
    -c:v vp9_qsv \
    -color_range full \
    -colorspace bt709 -color_primaries bt709 \
    -color_trc iec61966-2-1 \
    -crf 33 -b:v 1M \
    -keyint_min 96 -g 96 \
    -row-mt 1 -tile-columns 1 \
    -deadline good -threads 12 \
    encoded/video-0540p-crf33-b1m.mp4
fi

#ffmpeg \
#  -hide_banner \
#  -i $1 \
#  -map 0:a:0 -c copy -c:s mov_text -metadata:s:s:0 language=eng encoded/audio-opus-unknown.mp4

if [ "$3" = "true" ]; then
  ffmpeg \
    -hide_banner \
    -i $1 \
    -map_metadata -1 -map_chapters -1 -map 0:1 -c:a libopus -copyts -b:a 384k -af "channelmap=channel_layout=5.1" encoded/audio-surround-opus-384k.mp4 \
    -map_metadata -1 -map_chapters -1 -map 0:1 -c:a libopus -copyts -b:a 288k -af "channelmap=channel_layout=5.1" encoded/audio-surround-opus-288k.mp4 \
    -map_metadata -1 -map_chapters -1 -map 0:1 -c:a libopus -copyts -b:a 128k -ac 2 encoded/audio-stereo-opus-128k.mp4 \
    -map_metadata -1 -map_chapters -1 -map 0:1 -c:a libopus -copyts -b:a 96k -ac 2 encoded/audio-stereo-opus-96k.mp4
    #-map_metadata -1 -map_chapters -1 -map 0:1 -c:a flac -compression_level 8 -af "channelmap=channel_layout=5.1" encoded/audio-surround-flac-l8.mp4 \
    #-map_metadata -1 -map_chapters -1 -map 0:1 -c:a flac -compression_level 8 encoded/audio-stereo-flac-l8.mp4
  #ffmpeg \
  #  -hide_banner \
  #  -i $1 \
  #  -map 0:s:1 -c copy subs.pgs
fi
